--versión absoluta del administrador de grabaciones
require "import"
import "android.os.Handler"
import "android.widget.LinearLayout"
import "android.widget.SeekBar"
import "android.widget.TextView"
import "android.widget.Button"
import "android.widget.ImageView"
import "android.widget.ListView"
import "android.view.View"
import "android.media.MediaPlayer"
import "android.content.DialogInterface"
import "android.view.WindowManager"
import "android.content.Intent"
import "android.provider.Settings"
import "android.content.pm.PackageManager"
import "android.content.Context"
import "android.os.Build"
import "android.os.VibrationEffect"
import "android.os.Vibrator"
import "android.widget.Toast"
import "java.io.File"
import "java.lang.String"
import "java.io.FileReader"
import "java.io.FileWriter"
import "java.util.ArrayList"
import "android.view.KeyEvent"
import "java.io.BufferedWriter"
import "java.io.BufferedReader"
import "android.graphics.Color"
import "android.widget.EditText"
import "android.app.AlertDialog"
import "android.app.ProgressDialog"
import "android.graphics.drawable.ColorDrawable"
import "android.widget.Spinner"
import "android.widget.PageView"
import "android.widget.CardView"
import "android.widget.ArrayAdapter"
import "android.widget.RippleLayout"
import "android.widget.RelativeLayout"
import "android.media.AudioManager"
import "android.provider.MediaStore"
import "java.io.FileOutputStream"
import "java.io.OutputStreamWriter"
import "java.io.InputStreamReader"
import "java.io.FileInputStream"
import "java.text.SimpleDateFormat"
import "java.util.Date"
import "android.content.ContentValues"
import "android.media.MediaMuxer"
import "android.media.MediaFormat"
import "android.content.*"
import "android.net.Uri"
import "android.widget.*"
import "java.lang.reflect.Array"
import "java.lang.System"
import "android.os.Environment"
import "com.androlua.*"
 context = activity or service
 vibrator = context.getSystemService(Context.VIBRATOR_SERVICE)
vibrator.vibrate(100)

if isPlaying then
mediaPlayer.stop()
mediaPlayer.reset()
isPlaying = false
currentSoundFilePath = nil
end
--fin de bibliotecas
-- Variable global para almacenar la posición de la pista actual
currentSoundIndex = 0
 folderPath = "/storage/emulated/0/Grabación con Plugin"
 folder = File(folderPath)
if not folder.exists() then
 success = folder.mkdirs()
if success then
service.asyncSpeak("creado por sergio pina: " .. folderPath)
else
service.asyncSpeak("No se pudo crear la carpeta en: " .. folderPath)
end
end
 externalPath = Environment.getExternalStorageDirectory().getAbsolutePath()
 soundFolderPath = externalPath .. "/Grabación con Plugin/"
 soundFolder = File(soundFolderPath)
 soundFiles = soundFolder.listFiles()
 soundFilePaths = {}

if soundFiles ~= nil then
     soundFileCount = Array.getLength(soundFiles)

    if soundFileCount > 0 then
        -- Crear una tabla auxiliar para almacenar los archivos con su fecha de creación
         soundFileCreationTimes = {}
        for i = 0, soundFileCount - 1 do
             soundFile = soundFiles[i]
             soundFilePath = soundFile.getAbsolutePath()

             fileName = soundFile.getName()
             creationTime = soundFile.lastModified() -- Obtener la fecha de creación del archivo

            table.insert(soundFileCreationTimes, { filePath = soundFilePath, displayName = fileName, creationTime = creationTime })
        end

        -- Ordenar la tabla según la fecha de creación, de más viejo a más nuevo
        table.sort(soundFileCreationTimes, function(a, b)
            return a.creationTime < b.creationTime
        end)

        -- Agregar los archivos ordenados a la tabla soundFilePaths
        for i = 1, #soundFileCreationTimes do
             soundFile = soundFileCreationTimes[i]
            table.insert(soundFilePaths, { filePath = soundFile.filePath, displayName = soundFile.displayName })
        end
    else
        service.asyncSpeak("Nao se encontraram arquivos de som na pasta: " .. soundFolderPath)
        return false
    end
else
    service.asyncSpeak("No se pudo acceder a la carpeta: " .. soundFolderPath)
    return false
end

 adapterItems = {}
 isLongPress = false


 mediaPlayer = MediaPlayer()
--marcador funciones
 function cargarArchivos()
  -- Limpiar la tabla existente
  soundFilePaths = {}

  -- Obtener la lista de archivos en la carpeta
   soundFolderPath = externalPath .. "/Grabación con Plugin/"
   soundFolder = File(soundFolderPath)
   soundFiles = soundFolder.listFiles()

  if soundFiles ~= nil then
     soundFileCount = Array.getLength(soundFiles)

    if soundFileCount > 0 then
      -- Crear una tabla auxiliar para almacenar los archivos con su fecha de creación
       soundFileCreationTimes = {}
      for i = 0, soundFileCount - 1 do
         soundFile = soundFiles[i]
         soundFilePath = soundFile.getAbsolutePath()

         fileName = soundFile.getName()
         creationTime = soundFile.lastModified() -- Obtener la fecha de creación del archivo

        table.insert(soundFileCreationTimes, { filePath = soundFilePath, displayName = fileName, creationTime = creationTime })
      end

      -- Ordenar la tabla según la fecha de creación, de más viejo a más nuevo
      table.sort(soundFileCreationTimes, function(a, b)
        return a.creationTime < b.creationTime
      end)

      -- Agregar los archivos ordenados a la tabla soundFilePaths
      for i = 1, #soundFileCreationTimes do
         soundFile = soundFileCreationTimes[i]
        table.insert(soundFilePaths, { filePath = soundFile.filePath, displayName = soundFile.displayName })
      end

      -- Actualizar la vista de la lista
      
list.adapter.clear()
      for i, fileData in ipairs(soundFilePaths) do
        list.adapter.add(fileData.displayName)
      end
      list.adapter.notifyDataSetChanged()
    else
      service.asyncSpeak("Nao se encontraram arquivos de som na pasta: " .. soundFolderPath)
    end
  else
    service.asyncSpeak("Nao se pode acessar a pasta: " .. soundFolderPath)
  end
end
 function renameItem(position)
   fileData = soundFilePaths[position + 1]
   file = File(fileData.filePath)
   fileName, fileExtension = string.match(fileData.displayName, "(.-)(%.%w+)$") -- Obtener el nombre y la extensión del archivo

   renameDialog = LuaDialog(context)
  renameDialog.setTitle("Renombrar Archivo")

   input = EditText(context)
  input.setText(fileName) -- Utilizar solo el nombre del archivo, sin la extensión

  renameDialog.setView(input)

  renameDialog.setPositiveButton("Aceptar", DialogInterface.OnClickListener {
    onClick = function(dialog, which)
       newFileName = tostring(input.getText())
       newFilePath = file.getParent() .. "/" .. newFileName .. fileExtension -- Agregar la extensión nuevamente al nuevo nombre de archivo
       newFile = File(newFilePath)

      if file.renameTo(newFile) then
        fileData.displayName = newFileName .. fileExtension -- Actualizar el nombre de archivo en la lista
        adapterItems[position + 1] = fileData -- Actualizar el elemento en adapterItems

        -- Actualizar la vista de la lista
counterFile = File("/storage/emulated/0/orden.txt")
counterFile.delete()
        list.adapter.clear()
        for i, fileData in ipairs(soundFilePaths) do
          list.adapter.add(fileData.displayName)
        end
        list.adapter.notifyDataSetChanged()

        service.asyncSpeak("Arquivo renomeado corretamente.")
        -- dlg.dismiss() -- Comentado para mantener la interfaz abierta

guardarOrden()
cargarOrden()

-- Llamar a la función para cargar los archivos nuevamente
cargarArchivos()
      else
        service.asyncSpeak("Error al renombrar el archivo.")
      end

      dialog.dismiss()
    end
  })

  renameDialog.setNegativeButton("Cancelar", DialogInterface.OnClickListener {
    onClick = function(dialog, which)
      dialog.dismiss()
    end
  })

  renameDialog.show()
end
function cargarOrden()
     externalPath = Environment.getExternalStorageDirectory().getAbsolutePath()
     ordenFilePath = externalPath .. "/orden.txt"

     ordenFile = File(ordenFilePath)
    if ordenFile.exists() then
        soundFilePaths = {} -- Limpiar la lista actual de soundFilePaths

         inputStream = FileInputStream(ordenFile)
         reader = BufferedReader(InputStreamReader(inputStream))

         line = reader.readLine()
        while line ~= nil do
             filePath, displayName = line:match("([^,]+),([^,]+)")
            table.insert(soundFilePaths, { filePath = filePath, displayName = displayName })

            line = reader.readLine()
        end

        reader.close()
    end
end

cargarOrden() -- Cargar los datos al abrir la interfaz

 adapterItems = {}
for i, fileData in ipairs(soundFilePaths) do
    table.insert(adapterItems, fileData.displayName)
end

 function combineFiles2()
 combinedFileName = "arquivo_combinado"
     combinedFileExtension = ".wav" 
     combinedFilePath = soundFolderPath .. combinedFileName .. combinedFileExtension

     combinedFile = io.open(combinedFilePath, "wb")

    if combinedFile then
        for i, fileData in ipairs(soundFilePaths) do
             soundFile = io.open(fileData.filePath, "rb")

            if soundFile then
                 data = soundFile:read("*a")
                combinedFile:write(data)
                soundFile:close()
            else
                service.asyncSpeak("Erro ao abrir um arquivo: " .. fileData.filePath)
            end
        end

        combinedFile:close()
service.asyncSpeak("arquivos combinados")

        -- Actualizar la vista de la lista
        list.adapter.clear()
        for i, fileData in ipairs(soundFilePaths) do
            list.adapter.add(fileData.displayName)
        end
        list.adapter.notifyDataSetChanged()

        guardarOrden() -- Guardar el nuevo orden
        cargarOrden()
        cargarArchivos()
    else
        service.asyncSpeak("Erro ao criar um arquivo combinado.")
    end
end


--solo funciones
 function openFolder()
     intent = Intent(Intent.ACTION_VIEW)
    intent.setDataAndType(Uri.parse(soundFolderPath), "resource/folder")
    intent.setFlags(Intent.FLAG_ACTIVITY_NEW_TASK)
    context.startActivity(intent)
    counterFile = File("/storage/emulated/0/orden.txt")
counterFile.delete()
dlg.dismiss()
end

 function shareFile(position)
     selectedSoundFilePath = soundFilePaths[position + 1].filePath

    -- Llama a la función personalizada service.shareFile para compartir el archivo
    service.shareFile(selectedSoundFilePath)
guardarOrden()
dlg.dismiss()
end

 function deleteItem(position)
     fileData = soundFilePaths[position + 1]
     file = File(fileData.filePath)

     confirmationDialog = LuaDialog(context)
    confirmationDialog.setTitle("Eliminar Archivo")
    confirmationDialog.setMessage("¿Estás seguro de que deseas eliminar este archivo?")
    confirmationDialog.setPositiveButton("Eliminar", DialogInterface.OnClickListener {
        onClick = function(dialog, which)
            file.delete()
            table.remove(soundFilePaths, position + 1)
            service.asyncSpeak("Archivo eliminado correctamente.")
-- Actualizar el adaptador de la vista
         adapter = list.adapter
        adapter.clear()
        for i, fileData in ipairs(soundFilePaths) do
            adapter.add(fileData.displayName)
        end
        adapter.notifyDataSetChanged()

        guardarOrden() -- Guardar el nuevo orden
cargarOrden()
        end
    })
    confirmationDialog.setNegativeButton("Cancelar", DialogInterface.OnClickListener {
        onClick = function(dialog, which)
            dialog.dismiss()
        end
    })
    confirmationDialog.show()
end

--marcador borrado de archivos
 function deleteFiles()
     confirmationDialog = LuaDialog(context)
    confirmationDialog.setTitle("Eliminar Archivos")
    confirmationDialog.setMessage("¿Estás seguro de que deseas eliminar todos los archivos?")
    confirmationDialog.setPositiveButton("Eliminar", DialogInterface.OnClickListener {
        onClick = function(dialog, which)
            for i, fileData in ipairs(soundFilePaths) do
                 file = File(fileData.filePath)
                file.delete()
            end

            -- Eliminar archivo contador
             counterFile = File("/storage/emulated/0/contador.txt")
            counterFile.delete()
 counter3File = File("/storage/emulated/0/orden.txt")
counter3File.delete()

            soundFilePaths = {}
            service.asyncSpeak("Archivos eliminados correctamente.")
dlg.dismiss()
        end
    })
    confirmationDialog.setNegativeButton("Cancelar", DialogInterface.OnClickListener {
        onClick = function(dialog, which)
            dialog.dismiss()
        end
    })
    confirmationDialog.show()
end
--marcador inicios de función

 function closeDialog()
    if isPlaying then
        mediaPlayer.stop()
        mediaPlayer.reset()
        isPlaying = false
        currentSoundFilePath = nil
    end
guardarOrden()
dlg.dismiss()
end
 function subir(position)
    if position > 0 then
         fileData = table.remove(soundFilePaths, position + 1)
        table.insert(soundFilePaths, position, fileData)

        -- Actualizar el adaptador de la vista
         adapter = list.adapter
        adapter.clear()
        for i, fileData in ipairs(soundFilePaths) do
            adapter.add(fileData.displayName)
        end
        adapter.notifyDataSetChanged()

        guardarOrden() -- Guardar el nuevo orden
    end
end


 function bajar(position)
    if position < #soundFilePaths - 1 then
         fileData = table.remove(soundFilePaths, position + 1)
        table.insert(soundFilePaths, position + 2, fileData)

        -- Actualizar el adaptador de la vista
         adapter = list.adapter
        adapter.clear()
        for i, fileData in ipairs(soundFilePaths) do
            adapter.add(fileData.displayName)
        end
        adapter.notifyDataSetChanged()

        guardarOrden() -- Guardar el nuevo orden
    end
end
 function combineFiles()
     combinedFileName = "archivo_combinado"
     combinedFileExtension = ".mp3" 
     combinedFilePath = soundFolderPath .. combinedFileName .. combinedFileExtension

     combinedFile = io.open(combinedFilePath, "wb")

    if combinedFile then
        for i, fileData in ipairs(soundFilePaths) do
             soundFile = io.open(fileData.filePath, "rb")

            if soundFile then
                 data = soundFile:read("*a")
                combinedFile:write(data)
                soundFile:close()
            else
                service.asyncSpeak("Error al abrir el archivo: " .. fileData.filePath)
            end
        end

        combinedFile:close()
service.asyncSpeak("archivos combinados")

        -- Actualizar la vista de la lista
        list.adapter.clear()
        for i, fileData in ipairs(soundFilePaths) do
            list.adapter.add(fileData.displayName)
        end
        list.adapter.notifyDataSetChanged()

        guardarOrden() -- Guardar el nuevo orden
        cargarOrden()
        cargarArchivos()
    else
        service.asyncSpeak("Error al crear el archivo combinado.")
    end
end

function guardarOrden()
     externalPath = Environment.getExternalStorageDirectory().getAbsolutePath()
     ordenFilePath = externalPath .. "/orden.txt"

     ordenFile = File(ordenFilePath)
    if not ordenFile.exists() then
        ordenFile.createNewFile()
    end

     outputStream = FileOutputStream(ordenFile)

    for i, fileData in ipairs(soundFilePaths) do
         line = fileData.filePath .. "," .. fileData.displayName .. "\n"
        for j = 1, #line do
            outputStream.write(string.byte(line, j))
        end
    end

    outputStream.close()
end


--marcador fin de funciones para el administrador
-- Inicializar los resultados de búsqueda
currentMatchIndex = 1
matches = {}
--marcador funciones
function buscar(query)
    local queryLower = query:lower()
    matches = {}  -- Limpiar los resultados de la búsqueda anterior
    for i, item in ipairs(adapterItems) do
        local text = item
        if text:lower():find(queryLower) then
            table.insert(matches, i)  -- Almacenar el índice de las coincidencias
        end
    end

    if #matches > 0 then
        service.asyncSpeak("Se encontraron " .. tostring(#matches) .. " coincidencias.")
        currentMatchIndex = 1
list.setSelection(matches[currentMatchIndex] - 1)
    else
        service.asyncSpeak("sin resultados")
    end
end
function moveToNextMatch()
    if #matches > 0 then
        currentMatchIndex = currentMatchIndex + 1
        if currentMatchIndex > #matches then
            currentMatchIndex = 1  -- Envolverse al inicio después de la última coincidencia
        end
list.setSelection(matches[currentMatchIndex] - 1)
    else
        service.asyncSpeak("No hay resultados de búsqueda para moverse.")
    end
end
function scrollToMatch(matchIndex)
    local y = editTexts[matchIndex].getTop()
    scrollView.post(Runnable({run=function()
        scrollView.scrollTo(0, y)
    end}))
    service.asyncSpeak("Desplazándose a la coincidencia " .. tostring(currentMatchIndex) .. " de " .. tostring(#matches))
end

function nextMatch()
    if #matches > 0 then  -- Si hay coincidencias
        currentMatchIndex = currentMatchIndex % #matches + 1  -- Ir a la siguiente coincidencia, volver a la primera después de la última
        scrollToMatch(matches[currentMatchIndex])  -- Desplazarse a la coincidencia
    else
        service.asyncSpeak("sin resultados")
    end
end
--marcador función de tiempo para barra de deslizamiento
Runnable = luajava.bindClass("java.lang.Runnable")
DelayedRunnable = Runnable {
    run = function()
        currentPosition = mediaPlayer.getCurrentPosition()
        id_startTime.setText(formatTime(currentPosition))
        id_Progress.setProgress(currentPosition)
updateHandler.postDelayed(DelayedRunnable.run, 1000)
    end
}
currentPosition = 0
totalDuration = 0
updateHandler = Handler()

function formatTime(duration)
     minutes = math.floor(duration / 60000)
     seconds = math.floor((duration % 60000) / 1000)
    return string.format("%02d:%02d", minutes, seconds)
end

function stopUpdateHandler()
    updateHandler.removeCallbacksAndMessages(nil)
end


--marcador funciones de reproducción

function stopPauseButtonClicked()
    if isPlaying then
        -- Pausar la reproducción
        mediaPlayer.pause()
        isPlaying = false
    else
        -- Reanudar la reproducción
        mediaPlayer.start()
        isPlaying = true
    end
end






function playNextTrack()
    local nextPosition = currentSoundIndex + 1
    if nextPosition <= #soundFilePaths then
        local nextSoundFilePath = soundFilePaths[nextPosition].filePath
        playSound(nextSoundFilePath)
    end
end

function playPreviousTrack()
    local previousPosition = currentSoundIndex - 1
    if previousPosition >= 1 then
        local previousSoundFilePath = soundFilePaths[previousPosition].filePath
        playSound(previousSoundFilePath)
    end
end


function playSound(soundFilePath)

    if currentSoundFilePath == soundFilePath then
        -- Detener la reproducción de la pista actual
        mediaPlayer.stop()
        mediaPlayer.reset()
        isPlaying = false
        currentSoundFilePath = nil
        stopUpdateHandler()
        return
    end

    if isPlaying then
        mediaPlayer.stop()
        mediaPlayer.reset()
        stopUpdateHandler()
    end

    mediaPlayer.setAudioStreamType(AudioManager.STREAM_MUSIC)
    mediaPlayer.reset()
    mediaPlayer.setDataSource(soundFilePath)
    mediaPlayer.prepare()
    mediaPlayer.start()
    -- Aquí estamos extrayendo el nombre del archivo de la ruta completa del archivo.
    -- Este código asume que los nombres de las canciones no contienen ninguna barra ("/").
    local songName = string.match(soundFilePath, ".*/(.*)")

    -- Ahora, establece el nombre de la canción en el TextView que hemos añadido.
    id_songName.text = songName
    isPlaying = true
    currentSoundFilePath = soundFilePath

    totalDuration = mediaPlayer.getDuration()
    id_endTime.setText(formatTime(totalDuration))
    id_Progress.setMax(totalDuration)

    currentPosition = mediaPlayer.getCurrentPosition()
    id_startTime.setText(formatTime(currentPosition))
    id_Progress.setProgress(currentPosition)

    id_Progress.setOnSeekBarChangeListener({
        onProgressChanged = function(seekBar, progress, fromUser)
            -- Verificar si el cambio de progreso proviene del usuario (arrastre) y no de la reproducción automática
            if fromUser then
                -- Actualizar el progreso de reproducción en el reproductor de medios
                mediaPlayer.seekTo(progress)
                currentPosition = progress
                id_startTime.setText(formatTime(currentPosition))
            end
        end,
        onStartTrackingTouch = function(seekBar)
            -- Aquí puedes realizar alguna acción cuando se comienza a arrastrar la barra de progreso, si es necesario
        end,
        onStopTrackingTouch = function(seekBar)
            -- Aquí puedes realizar alguna acción cuando se detiene el arrastre de la barra de progreso, si es necesario
        end
    })

    -- Encuentra el índice de la pista que se está reproduciendo actualmente
    local currentTrackIndex = nil
    for i, fileData in ipairs(soundFilePaths) do
        if fileData.filePath == soundFilePath then
            currentTrackIndex = i
            break
        end
    end

    -- Si se encontró la pista, mueve el scroll de la lista para que la pista se muestre al principio
    if currentTrackIndex then
        list.setSelection(currentTrackIndex - 1)
    end



    updateHandler.postDelayed(DelayedRunnable, 1000)

    run = function()
        currentPosition = mediaPlayer.getCurrentPosition()
        id_startTime.setText(formatTime(currentPosition))
        id_Progress.setProgress(currentPosition)
        updateHandler.postDelayed(this, 1000)
    end

    for i, fileData in ipairs(soundFilePaths) do
        if fileData.filePath == soundFilePath then
            currentSoundIndex = i
            break
        end
    end

    mediaPlayer.setOnCompletionListener({
        onCompletion = function(mp)
            nextPosition = currentSoundIndex + 1

            if nextPosition <= #soundFilePaths then
                nextSoundFilePath = soundFilePaths[nextPosition].filePath
                playSound(nextSoundFilePath)
            end
        end
    })
end
--marcador del layout
layout = {
    LinearLayout;
    layout_width = "fill";
    layout_height = "fill";
backgroundColor = "0xFF000000";
    orientation = "vertical";
    {
        TextView;
        text = "administrador absoluto";
        textSize = "10sp";
        gravity = "center";
layout_width = "fill";
        padding = "16dp";
    },
{
TextView;
id = "musicFileCount";
text = "Foram encontrados " .. #soundFilePaths .. " gravacoes na pasta.";
textSize = "10sp";
gravity = "center";
layout_width = "fill";
padding = "10dp";
},
    {
        EditText;
        id = "searchEditText";
        hint = "Buscar...";
textSize = "10sp";
        layout_width = "fill";
        layout_height = "wrap";
    },
    {
        Button;
        text = "Mais resultados";
textSize = "10sp";
        layout_width = "fill";  -- Aquí se ha modificado el layout_width a "fill"
        onClick = function(view)
            moveToNextMatch()
        end;
    },
    {
        CardView;
        layout_width = "fill";
        layout_weight = "1";
        backgroundColor = "0xFF202125";
        cardElevation = 0;
        radius = 0;
        {
            PageView;
            id = "id_page";
            layout_width = "fill";
            layout_height = "fill";
backgroundColor = "0xFF000000";
            padding = "5dp";
            pages = {
                --marcador páginas
                {
                    ListView;
                    id = "list";
                    fastScrollEnabled = false;
                    layout_width = "fill";
                    layout_height = "fill";
                },
            },
        },
    },
    {
        CardView;
        layout_width = "fill";
        layout_margin = "0dp";
        backgroundColor = "0xFF202125";
        cardElevation = 0;
        radius = 0;
        id = "t2";
        {
            LinearLayout;
            layout_width = "fill";
            orientation = "vertical";
            {
                LinearLayout;
                layout_width = "fill";
                layout_margin = "6dp";
                {
                    SeekBar;
                    id = "id_Progress";
                    layout_width = "fill";
                    layout_height = "wrap";
                },
},
{
    TextView;
    text = "";
layout_width = "fill";
    textColor = "0xFFFFFFFF";
    id = "id_songName";
textSize = "10sp";
},
            {
                TextView;
                text = "00:00";
textSize = "10sp";
                textColor = "0xFFFFFFFF";
                id = "id_startTime";
            },
            {
                TextView;
                text = "00:00";
textSize = "10sp";
                textColor = "0xFFFFFFFF";
                id = "id_endTime";
            },
            {
                LinearLayout;
                layout_width = "fill";
                orientation = "horizontal";
                {
                    Button;
                    id = "id_previousButton";
                    text = "Faixa anterior";
                    layout_weight = "1";
                    onClick = "playPreviousTrack";
                },
                {
                    Button;
                    id = "id_playpauseButton";
                    text = "Reproduzir/Pausar";
                    layout_weight = "1";
                    onClick = "stopPauseButtonClicked";
                },
                {
                    Button;
                    id = "id_nextButton";
                    text = "Faixa seguinte";
                    layout_weight = "1";
                    onClick = "playNextTrack";
                },
            },
        },
    },
--marcador botones nuevos
{
Button,
id = "btnCombineFiles",
text = "combinar no formato mp3",
textSize = "10sp";
layout_width = "fill";  -- Aquí se ha modificado el layout_width a "fill"
onClick = combineFiles
},
{
Button,
id = "btnCombineFiles2",
text = "combinar no formato wav",
textSize = "10sp";
layout_width = "fill";  -- Aquí se ha modificado el layout_width a "fill"
onClick = combineFiles2
},
    {
        Button,
        id = "btnOpenFolder",
        text = "Abrir pasta",
textSize = "10sp";
layout_width = "fill";  -- Aquí se ha modificado el layout_width a "fill"
        onClick = openFolder
    },
    {
        Button,
        id = "btnDeleteItem",
        text = "Excluir Arquivos",
textSize = "10sp";
layout_width = "fill";  -- Aquí se ha modificado el layout_width a "fill"
        onClick = deleteFiles
    },
{
Button,
id = "btncloseDialog",
text = "salvar e fechar",
textSize = "10sp";
layout_width = "fill";  -- Aquí se ha modificado el layout_width a "fill"
onClick = closeDialog
},
}
--marcador fin de botones

mediaPlayer = MediaPlayer()
isPlaying = false
currentSoundFilePath = nil

dlg = LuaDialog(service)
dlg.View = loadlayout(layout)

adapterItems = {}
for i, fileData in ipairs(soundFilePaths) do
    table.insert(adapterItems, fileData.displayName)
end

list.adapter = ArrayAdapter(service, android.R.layout.simple_list_item_1, adapterItems)

dlg.show()
searchEditText.addTextChangedListener({
onTextChanged = function(s, start, before, count)
buscar(s.toString())
end
})

list.onItemClick = function(l, v, position, id)
    vibrator.vibrate(100)

    selectedSoundFilePath = soundFilePaths[position + 1].filePath
    playSound(selectedSoundFilePath)
end
--marcador inicio de pulsado largo
list.onItemLongClick = function(l, v, position, id)
    isLongPress = true
    vibrator.vibrate(100)
     options = {"Eliminar", "Compartir", "Renombrar", "Subir", "Bajar"}

     dialog = LuaDialog(context)
    dialog.setTitle("Opciones")

     layout = {
        LinearLayout,
        orientation = LinearLayout.VERTICAL,
        {
            Button,
            text = options[1],
layout_width = "fill";  -- Aquí se ha modificado el layout_width a "fill"
            onClick = function(view)
                deleteItem(position)
                dialog.dismiss()
            end
        },
        {
            Button,
            text = options[2],
layout_width = "fill";  -- Aquí se ha modificado el layout_width a "fill"
            onClick = function(view)
                shareFile(position)
                dialog.dismiss()
            end
        },
        {
            Button,
            text = options[3],
layout_width = "fill";  -- Aquí se ha modificado el layout_width a "fill"
            onClick = function(view)
                renameItem(position)
                dialog.dismiss()
            end
        },
        {
            Button,
            text = options[4],
layout_width = "fill";  -- Aquí se ha modificado el layout_width a "fill"
            onClick = function(view)
                subir(position)
                dialog.dismiss()
            end
        },
        {
            Button,
            text = options[5],
layout_width = "fill";  -- Aquí se ha modificado el layout_width a "fill"
            onClick = function(view)
                bajar(position)
                dialog.dismiss()
            end
        }
    }

--marcador botones de función

     contentView = loadlayout(layout)
    dialog.setView(contentView)
    dialog.setCancelable(true)
    dialog.show()

    return true  -- Indicar que se ha manejado el evento
end